<?php /*>*/ if (!defined('PmWiki')) exit();
#
# textpattern/textpattern.php v0.2
#
# PmWiki TextPattern skin code
# Copyright 2005 Tim Rhodes (trhodes@trhodes.net)
# Credit to Dominique Faure (dfaure@cpan.org) for "Grease Skin",
# which was used as that starting base for TexPattern Skin.
# Inspired by 'TextPattern' default skin at http://www.textpattern.com
#
# This file is part of the TextPattern skin; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.
#
global $SkinPartFmt, $WikiTitle, $Slogan, $Skincopyright;
# Slogan to be printed under Page Title
$Slogan = "What goes up must come down.";
# Copyright to be displayed in page footer
$Skincopyright = "&copy; 2005, Tim Rhodes and contributing authors, all rights reserved.";

SDVA($SkinPartFmt, array(
'wikititle' => "$WikiTitle - {\$Titlespaced}",
'title' => '{$WikiTitle}',
'subtitle' => '[[{$Groupspaced}]]&nbsp;&middot;&nbsp;[[{$Name}?action=search&q=link={$FullName} | $[{$Namespaced}]]]',
'actions' => '
* %item accesskey=$[ak_search]%[[$[Search] -> Site.Search]]
* %item accesskey=$[ak_recentchanges]%[[$[Recent Changes]]]
',
'pageactions' => '
* [[$[Printable View] -> {$FullName}?action=print]]
* [[$[Page History] -> {$FullName}?action=diff]]
* [[$[Edit Page] -> {$FullName}?action=edit]]
* [[$[Upload] -> {$FullName}?action=upload]]
',
'sep' => '&middot;',
));

function RenderTitle($pagename) {
  global $SkinPartFmt, $PCache;
  if(!isset($PCache[$pagename]['skin_wikititle']))
    $PCache[$pagename]['skin_wikititle'] =
      preg_replace("/(<[^>]+>|\r\n?|\n\r?)/", '', MarkupToHTML($pagename, $SkinPartFmt['wikititle']));
  print $PCache[$pagename]['skin_wikititle'];
}

function RenderPart($pagename, $part) {
  global $SkinPartFmt, $PCache;
  $n = "skin_$part";
  if(!isset($PCache[$pagename][$n]))
    $PCache[$pagename][$n] =
      preg_replace("/<\/?p>/", '', MarkupToHTML($pagename, $SkinPartFmt[$part]));
  print $PCache[$pagename][$n];
}

function RenderActions($pagename, $actionslist) {
	global $SkinPartFmt, $PCache;
  if(!isset($PCache[$pagename]['skin_actions'])) {
  	$pagelist = preg_split('/\s+/', $actionslist, -1, PREG_SPLIT_NO_EMPTY);
  	foreach($pagelist as $p) {
  		if (PageExists($p)) {
  			$page = RetrieveAuthPage($p, 'read', false, READPAGE_CURRENT);
  			$text = $page['text'];
  			break;
  		}
  	}
    SDV($text, $SkinPartFmt['pageactions']);
    $text = preg_replace("/(\r\n|\n?\r)/", "\n", "$SkinPartFmt[actions]$text");
  	$PCache[$pagename]['skin_actions'] =
  	  preg_replace('/(<\/li>)(?=\s*<li)/s', "$SkinPartFmt[sep] \\1", MarkupToHTML($pagename, $text));
  }
	print $PCache[$pagename]['skin_actions'];
}

# sidebar markup
Markup('nosidebar', 'directives', '/\\(:nosidebar:\\)/i', "mu_nosidebar");
function mu_nosidebar() {SetTmplDisplay('PageRightFmt',0);}

# links decoration
global $IMapLinkFmt, $LinkPageCreateFmt, $LinkUploadCreateFmt;

$IMapLinkFmt['Attach:'] =
"<a class='attachlink' href='\$LinkUrl' rel='nofollow'>\$LinkText</a>";
$LinkUploadCreateFmt =
"<a class='createlinkupload' href='\$LinkUpload'>\$LinkText</a>";
$LinkPageCreateFmt =
"<a class='createlinktext' href='\$PageUrl?action=edit'>\$LinkText</a>";

# trails decoration
global $TrailFmt;
$TrailFmt = array(
	'head' => '&#8592; ',
	'tail' => ' &#8594;',
	'headB' => '&#8592; ',
	'tailB' => ' &#8594;',
	'sep' => ' &middot; ',
);

Markup('googlesearch', 'directives', '/\\(:googlesearch:\\)/',"mu_googlesearch");
function mu_googlesearch() {
  return Keep("
<FORM method=GET action='http://www.google.com/search' target='_blank'>
<TABLE><tr><td>
Google Safe Search
<A HREF='http://www.google.com/search?safe=vss'></A>
<INPUT TYPE=text name=q size=150px maxlength=255 value=''>
<INPUT type=hidden name=safe value=strict>
<INPUT type=submit name=sa value='Google'>
</td></tr></TABLE>
</FORM>
");
}

